#coding:latin-1
"""
ce programme rcupre automatique les discours du premier ministres et du prsident
"""
import urllib2, re, os, codecs, xml.dom.minidom, StringIO, htmlentitydefs, HTMLParser

endLine ="\r\n"

class DiscourPolitique :
    
    _mois = [u"janvier", u"fvrier", u"mars", u"avril", u"mai", u"juin",
            u"juillet", u"aot", u"septembre", u"octobre", u"novembre", u"dcembre" ]
    
    def __init__ (self, website, pattern, regexp, fields, maxpage = 50, utf8 = True) :
        self.website = website
        self.pattern = pattern
        self.maxpage = 50
        self.regexp  = re.compile (regexp)
        self.fields  = { }
        self.utf8    = utf8
        for k,v in fields.iteritems () :
            self.fields[k] = re.compile (v)
        
    def GetAndSaveRaw (self, folder = "discoursBrut", log = False) :
        """
        rcupre la liste de tous les discours (format Html)
        et les enregistre dans le rpertoire folder
        retourne cette liste
        """
        if not os.path.exists (folder) :
            os.mkdir (folder)
        
        res = []
        for i in xrange (0, self.maxpage) :
            pat = self.pattern.replace ("__PAGE__", str(i))
            url = self.website + pat
            try :
                u = urllib2.urlopen (url)
                text = u.read ()
                u.close ()
            except Exception, e :
                if i == 0 :
                    raise Exception ("stopped at first page " + endLine + url + endLine + str(e))
                elif log :
                    print "erreur page ", i
                    print e
                break
                    
            all = self.regexp.findall (text)
            unique = []
            for a in all :
                if a not in unique : unique.append(a)
            all = unique
            
            if log : print "page ", i, " found ", len(all), " count ", len(res), ":", url
            if len(all) > 0 :
                temp = [ self.website + _ for _ in all ]
            else :
                break
                
            for n,url in enumerate(temp) :
                file = url.split("/")[-1]
                if not file.endswith(".html") :
                    file = file + ".html"
                file = os.path.join(folder, file)
                if not os.path.exists (file) :
                    try :
                        u = urllib2.urlopen (url)
                        text = u.read ()
                        u.close ()
                        if len(text) == 0 :
                            raise Exception ("download failed for " + url)
                        f = open (file, "w")
                        f.write (text)
                        f.close()
                        res.append (file)
                        if log : print "    ",n,"wrote ", file
                    except Exception, e :
                        if log :
                            print "    skipping ", url, " *** ", e
            
        return res
        
    def xmlParsingLongestDiv (self, text) :
        class MyHTMLParser(HTMLParser.HTMLParser):
            def __init__ (self) :
                HTMLParser.HTMLParser.__init__(self)
                self.mtag=[]
                self.mvalue=[]
                self.mall=[]
            def handle_starttag(self, tag, attrs):
                if tag == "div" :
                    self.mtag.append(tag)
                    self.mvalue.append([])
                elif len(self.mtag)>0 :
                    self.mvalue[-1].append(" ")
            def handle_endtag(self, tag):
                if tag == "div" :
                    self.mall.append((self.mtag[-1],"".join(self.mvalue[-1])))
                    self.mtag.pop()
                    self.mvalue.pop()
                elif len(self.mtag)>0 :
                    if tag == "p" or tag == "br":
                        self.mvalue[-1].append(endLine)
                    else :
                        self.mvalue[-1].append(" ")
            def handle_data(self, data):
                if len(self.mtag)>0 :
                    self.mvalue[-1].append(data)
                
        parser = MyHTMLParser()
        text = text.replace(" -g8\" "," ")
        parser.feed(text)
        
        best = ""
        for tag,value in parser.mall :
            if tag == "div" and len(value)>len(best) :
                best = value
        res = best.replace ("<p>","").replace("</p>",endLine).replace("\r","").replace ("<br />",endLine).replace ("<br>",endLine)
        exp = re.compile("[|]((.|\n){5,50}) ")
        nb = exp.findall(res)
        if (len(nb) == 0 or len(res) > 10000) and "if (window.xtparam!=null)" not in res:
            return res
        else :
            return ""


    def html_unescape(self, text):
        """Removes HTML or XML character references 
          and entities from a text string.
          keep &amp;, &gt;, &lt; in the source code.
        from Fredrik Lundh
        http://effbot.org/zone/re-sub.htm#unescape-html
        """
        def fixup(m):
            text = m.group(0)
            if text[:2] == "&#":
                try:
                    if text[:3] == "&#x":
                       return unichr(int(text[3:-1], 16))
                    else:
                       return unichr(int(text[2:-1]))
                except ValueError:
                    pass    
            else:
                # named entity
                try:
                    if text[1:-1] == "amp":
                       text = "&amp;amp;"
                    elif text[1:-1] == "gt":
                       text = "&amp;gt;"
                    elif text[1:-1] == "lt":
                       text = "&amp;lt;"
                    else:
                       text = unichr(htmlentitydefs.name2codepoint[text[1:-1]])
                except KeyError:
                    pass
            return text # leave as is
        return re.sub("&#?\w+;", fixup, text)        
        
    def force_unicode (self, text) :
        exp = re.compile("([0-9]+):")
        turn = 0
        while True :
            try :
                text = text.encode("ascii", errors="ignore")
                break
            except UnicodeDecodeError, e :
                pos = exp.findall(str(e))
                pos = int(pos[0])
                print text[pos-50:pos+50]
                print text[pos-5:pos+5]
                print list(text[pos-5:pos+5])
                text = text.replace("ô","o").replace("é","e").replace("","a")
                text = text.replace(" "," ").replace("’","'").replace("a","c")
                text = text.replace("a","u").replace("a","e").replace("a","E")
                text = text.replace("a","a").replace("a","e").replace("a´","o")
                text = text.replace("a©","e").replace("a","e").replace("©","e")
                text = text.replace("a","u").replace("€","E").replace("a","i")
                text = text.replace('\xa0', " ").replace("œ","oe").replace("«"," ")
                text = text.replace ("»"," ").replace("e ","ei").replace("", " ")
                turn+=1
                if turn>100 :
                    stop
        return text
        
    def Extract(self, source, dest, log = False) :
        """
        extrait tous les discours depuis le texte HTML et les place dans le rpertoire destination
        cre in fichier index.txt avec les champs demands dans field
        """
        if not os.path.exists (dest) :
            os.mkdir (dest)
            
        files = os.listdir (source)
        files = [ _ for _ in files if _.endswith(".html") ]
        memo  = []
        
        for ii,name in enumerate(files) :
            filename = name.replace(".html",".txt")
            filename = os.path.join(dest,filename)
            if os.path.exists (filename) :
                if log : print "skipping ", ii, name
                continue
            
            if log : print "reading", ii,name

            f = codecs.open (os.path.join(source, name), "r", "utf8")


            #f = open (os.path.join(source, name), "r")
            
            
            try :
                text = f.read()
                f.close ()
            except UnicodeDecodeError, e :
                if log : print "unicode issue with ", name, " ::: ", e
                f = open (os.path.join(source, name), "r")
                text = f.read()
                f.close ()
                text =self.force_unicode(text)
            
            fields = { }
            
            for k,v in self.fields.iteritems () :
                val = v.findall(text)
                fil = []
                for ff in val :
                    fil.append (ff)
                    
                if len(fil)>0 :
                    val = fil[0]
                    fields[k] = val
                else :
                    val = None
                    
            
            for f in self.fields :
                if f in fields :
                    if f == "date" :
                        v = fields[f]
                        if len(v[1])==2 :
                            jour = v[2]
                            mois = v[1]
                            annee = v[0]
                            fields[f] = u"%s.%s.%s" % (annee, mois, jour)
                        else :
                            jour = v[0]
                            mois = u"%02d" % (DiscourPolitique._mois.index(v[1])+1)
                            annee = v[2]
                            fields[f] = u"%s.%s.%s" % (annee, mois, jour)
                    else :
                        v = fields[f]
                        fields [f] = self.html_unescape(v)
                        
            # body
            body = self.xmlParsingLongestDiv (text)
            fields["len"]=str(len(body))
            
            if "date" not in fields or len(fields["date"]) != 10:
                raise Exception ("not date for " + name)
                
            
            if len(body) > 100 :
                # end
                fields["name"]=os.path.basename(filename)
                f    = codecs.open(filename,"w","utf8")
                f.write(body)
                f.close()
                memo.append(fields)
            else :
                if log : print "skipping because too short", len(body)
            
            
        # end
        keys = { }
        for fi in memo :
            for k in fi :
                if k not in keys : keys[k]=None
        keys = keys.keys()
        keys.sort()
        
        filename = os.path.join(dest,"index.txt")
        f = codecs.open(filename,"w","utf8")
        for fi in memo :
            val = [ fi.get(k,"") for k in keys ]
            f.write(u"\t".join(val)+endLine)
        f.close()
            
        
        
        
                    
class DiscoursPremierMinistre (DiscourPolitique) :

    def __init__ (self) :
        pattern = "recherche/discours?page=__PAGE__&keys=discours&type=intervention&tid=All&field_acteur_nid=All&field_ministere_nid=All&date_year=&date_month=&filters=type%3Aintervention&solrsort=created%20desc"        
        regexp  = """<a title="Cliquer ici pour voir la page" href="/(premier-ministre/[-a-z]+)">"""
        fields  = { "title" : "<title>(.+)</title>",
                    "date": """<div title="Date" class="formated-date"><span title="Jour" class="d">([0-9]+)</span>.<span title="Mois" class="m">([a-zA-Z]+)</span><span title="Ann.{0,2}e" class="Y">([0-9]+)</span>""",
                    }
        DiscourPolitique.__init__(  self, 
                                    "http://www.premier-ministre.gouv.fr/", 
                                    pattern, 
                                    regexp,
                                    fields)
                                    
class DiscoursPresident (DiscourPolitique) :

    def __init__ (self) :
        pattern = "recherche/search.php?q=discours&bloc_recherche_valider_x=0&bloc_recherche_valider_y=0&start=__PAGE__0&category=&media_category="        
        regexp  = """href='http://www.elysee.fr/(president/.+)[?]search=discours&amp;xtmc=discours&amp;xcr="""
        fields  = { "title" : "<title>(.+)</title>",
                    "date": """<meta name="Last-Modified" content="([0-9]+)-([0-9]+)-([0-9]+)" />""",
                    }
        DiscourPolitique.__init__(  self, 
                                    "http://www.elysee.fr/", 
                                    pattern, 
                                    regexp,
                                    fields)
                                    
if __name__ == "__main__" :
    dis = DiscoursPremierMinistre()
    #dis.GetAndSaveRaw(folder = "discoursBrutPM", log = True)
    #dis.Extract (source = "discoursBrutPM", dest = "discoursPM", log = True) 
    dis = DiscoursPresident()
    #dis.GetAndSaveRaw(folder = "discoursBrutPres", log = True)
    dis.Extract (source = "discoursBrutPres", dest = "discoursPres", log = True) 
 

